package net.jaekl.cfb.xml;

import java.io.PrintWriter;

import org.xml.sax.Attributes;

import net.jaekl.qd.xml.MissingAttributeException;
import net.jaekl.qd.xml.ParseResult;
import net.jaekl.qd.xml.XmlParseException;

public class LocalVariable extends ParseResult {

	static final String TAG = "LocalVariable";
	static final String[] INTERNAL = { };
	static final Object[][] EXTERNAL = { };

	static final String NAME = "name";
	static final String ROLE = "role";
	
	String m_name;
	String m_role;
	
	public LocalVariable() {
		super(TAG, INTERNAL, EXTERNAL);
		
		m_name = m_role = null;
	}
	
	@Override
	public void handleMainAttributes(Attributes attr)
		throws MissingAttributeException
	{
		m_name = getRequiredAttr(TAG, attr, NAME);
		m_role = getRequiredAttr(TAG, attr, ROLE);
	}
	
	@Override
	public void endContents(String uri, String localName, String qName, String chars) 
		throws XmlParseException 
	{
	}

	@Override
	public void endExternal(String uri, String localName, String qName)
		throws XmlParseException 
	{
		// no-op
	}
	
	@Override
	public void dump(PrintWriter pw, int indent) 
	{
		super.dump(pw, indent);
		String tab = String.format("%" + (indent + 2) + "s", "");
		
		pw.println(tab + NAME + "=" + m_name);
		pw.println(tab + ROLE + "=" + m_role);
	}
}
